
TYPO3.Neos - Task # 10086

Story # 10367 (Resolved): As Roger, I want to have Guidelines for JavaScript and CSS Programming

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category:
Created: 2010-10-06 Assigned To: Sebastian Kurfuerst
Updated: 2012-08-31 Due date:
Subject: Create a JavaScript CGL for Phoenix
Description

Create a JavaScript CGL for Phoenix

Related issues:
precedes TYPO3.Neos - Task # 10369: Add API Documentation to JavaScript files... Resolved 2010-10-07 2010-10-07

History
#1 - 2010-10-06 08:50 - Christian Müller

There is a Draft in the wiki, I think from Nils:
http://forge.typo3.org/projects/typo3v5-core/wiki/DRAFT_JavaScript_CGL

#2 - 2010-10-15 11:13 - Karsten Dambekalns
- Target version set to 707

#3 - 2010-10-16 10:22 - Sebastian Kurfuerst

Nils and I will do that.

#4 - 2010-10-16 16:57 - Sebastian Kurfuerst
- % Done changed from 0 to 20

#5 - 2010-10-19 21:45 - Karsten Dambekalns
- Category set to Documentation
- Status changed from New to Accepted
- Assigned To set to Sebastian Kurfuerst

#6 - 2010-10-20 12:20 - Sebastian Kurfuerst
- Target version changed from 707 to 711

#7 - 2010-10-21 10:03 - Sebastian Kurfuerst
- Parent task set to #8797

#8 - 2010-10-21 10:31 - Sebastian Kurfuerst
- Parent task changed from #8797 to #10367

#9 - 2010-10-21 22:13 - Rens Admiraal

Draft CGL looks good, a few comments:

- The @private annotation is used in the example class, but should be stated clearly in the CGL
- I think we agreed to use _methodName for private methods, this should also be added

#10 - 2010-10-25 17:58 - Sebastian Kurfuerst
- File js-cgl-export.pdf added

added a file with the current JS CGL version

#11 - 2010-10-25 18:17 - Nils Dehl

Sebastian Kurfuerst wrote:

added a file with the current JS CGL version

wow looks good so far,

for array/ object code formating we can use
http://google-styleguide.googlecode.com/svn/trunk/javascriptguide.xml#Code_formatting
as discussion base

#12 - 2010-10-27 07:37 - Sebastian Kurfuerst
- File js-cgl-export-v2.pdf added
- % Done changed from 20 to 80

attached is version 2, after discussion yesterday.

#13 - 2010-10-27 10:10 - Sebastian Kurfuerst
- File deleted (js-cgl-export.pdf)

#14 - 2010-10-27 16:20 - Nils Dehl

TODO: find out how to make cross-references

{@link #methodOne This is a example link to method one}

how to nicely format multiline-text inside doc comments

to have a nice multiline output in the rendert api you have to format the code with <br />, <pre> ..

 * <br/>
 * Description of the class. Make it as long as needed,
 * feel free to explain how to use it.
 * This is a sample class <br/>
 * The file encoding should be utf-8 <br/>
 * UTF-8 Check: öäüß <br/>
 * {@link #methodOne This is a example link to method one} <br/>

a single var statement

i also prefer version 1

#15 - 2010-10-27 16:34 - Nils Dehl

7 ExtJS specific things

extendig a store example:

F3.TYPO3.Content.DummyStore = Ext.extend(Ext.data.Store, {

    constructor: function(cfg) {
        cfg = cfg || {};
        var config = Ext.apply(
            {
                autoLoad: true
            },
            cfg
        );

        F3.TYPO3.Content.DummyStore.superclass.constructor.call(
            this,
            config
        );
    }
});
Ext.reg('F3.TYPO3.Content.DummyStore', F3.TYPO3.Content.DummyStore);

#16 - 2010-10-27 21:11 - Christian Müller

I had a look and didn't find something to add right now. Looks already quite good. I would have something like an Appendix and put the JSlint
explanation there as it has nothing to do with code style but more with testing the code style...
I will think about chapter 7 (ExtJS) I think there is more to that.

#17 - 2010-10-29 08:28 - Sebastian Kurfuerst

Hey,

I was thinking about @return {void} -- should we require this? I think it adds not really any value, so why add that to methods and clutter the code with
it?

Greets,
Sebastian

#18 - 2010-10-29 08:57 - Karsten Dambekalns

Sebastian Kurfuerst wrote:

I was thinking about @return {void} -- should we require this? I think it adds not really any value, so why add that to methods and clutter the code
with it?

For the same reason we use it in the PHP code: if it's there you can be sure it has not simply been forgotten. It tells about the intention.

#19 - 2010-10-29 13:11 - Fabien Udriot

It would make sense for me to have return {void} documented since it gives additional information in the method's description particularly if the method
becomes a bit longer... Also, I can imagine this may be useful when reading JSDoc.

#20 - 2010-11-01 16:59 - Sebastian Kurfuerst

ok, I updated the CGLs, now stating that @return {void} is required if there is no return value.

#21 - 2010-11-03 19:20 - Sebastian Kurfuerst

The tool https://github.com/kassens/javascript-formatter looks quite promising -- It is not fully done yet and I am not fully sure if it covers all cases -- but
to me it makes perfect sense to do it this way :)

#22 - 2010-11-04 14:50 - Sebastian Kurfuerst
- Status changed from Accepted to New

#23 - 2010-11-11 15:25 - Robert Lemke
- Status changed from New to Needs Feedback

#24 - 2010-11-24 12:42 - Robert Lemke
- Status changed from Needs Feedback to Resolved
- Estimated time set to 0.00
- Remaining (hours) set to 0.0

#25 - 2012-08-31 10:38 - Robert Lemke
- Project changed from Base Distribution to TYPO3.Neos

Files
js-cgl-export-v2.pdf 167.5 kB 2010-10-27 Sebastian Kurfuerst
